#ifndef EVENT_H
#define EVENT_H

#include <string>
#include <functional>

typedef std::function<void(const std::string&)> string_callback_t;
typedef std::function<void(uint8_t)> uint8_t_callback_t;

void set_oled_log_handler(string_callback_t handler);
void log_oled(const std::string& message);

void set_wlan_connection_status_handler(uint8_t_callback_t handler);
void update_wlan_connection_status(uint8_t status);

void set_mqtt_connection_status_handler(uint8_t_callback_t handler);
void update_mqtt_connection_status(uint8_t status);

#endif